extern "C"
{

// OnStart: called after plugin is loaded
//			MDInstance: handle to calling module
//			MDWnd: handle to Multidec windows (for sending messages)
//			Log_Set: 1 if LOG is selected in Multidec.ini
//			DLL_ID: id of this DLL for Multidec
//			*My_Hot_Key: assignable hotkey of this plugin
//			Api_Version: identifier of the calling API version (not in MD8.0 and MD8.1)
//			*Keep_me_running: 0 to keep the plugin in memory, any other unloads (not in MD8.0 and MD8.1)
void On_Start(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set, int DLL_ID,
              char *My_Hot_Key,char *Api_Version, int *Keep_me_running );

// On_Menu_Select: called when a menu in Multidec is selected (in any plugin !)
//			The IDs are taken from the MENU resource "EXTERN"
void On_Menu_Select(unsigned int MenuID );
void On_Channel_Change( struct TProgramm82 CurrentProgramm );

int PROG_Get_Signal_Level( void );
int PROG_Send_Diseqc( void );

#define PROGAPI_GET_SIGNAL_LEVEL 0x01022001
struct TProgAPISignalState
 {	DWORD   dwSize; 	// Length of this structure
	DWORD   dwQuality;	// Quality: 0-100
	DWORD   dwLevel;	// Level: 0-100
 } ;


#define PROGAPI_SEND_DISEQC 0x01022002
struct TProgAPIDiSEqCmd
 { DWORD dwSize;
   DWORD dwResult;
   DWORD dwCmdLength;
   char  Cmd[16];
 } ;

#define PROGAPI_GET_CHANNEL_NAME 0x01022003
struct TProgAPIGetChannelName
 { DWORD dwSize;
   DWORD dwSID;
   DWORD dwTID;
   DWORD dwSatPosition;
   char ChannelName[32];
   char ProviderName[32];
   char ChannelCaption[128];
 } ;

// structure TPIDFilters extraite de MDExtern.h

struct TPIDFilters
{  char           FilterName[5];
   unsigned char  FilterId;
   unsigned short PID;
} ;

// structure TProgramm82 extraite de MDExtern82.h

#define MAX_CA_SYSTEMS 32
#define MAX_PID_IDS 32

struct TCA_System82
{  unsigned short CA_Typ;
   unsigned short ECM;
   unsigned short EMM;
   unsigned int   Provider_Id;   // Neu -> Viaccess und Seca Provider in der Kanalliste
};

struct TProgramm82
{ char              Name[30];
  char              Anbieter[30];
  char              Land[30];
  unsigned long     freq;
  unsigned char     Typ;
  unsigned char     volt;
  unsigned char     afc;
  unsigned char     diseqc;
  unsigned int      srate;
  unsigned char     qam;
  unsigned char     fec;
  unsigned char     norm;
  unsigned short    tp_id;
  unsigned short    Video_pid;
  unsigned short    Audio_pid;
  unsigned short    TeleText_pid;               // Teletext PID
  unsigned short    PMT_pid;
  unsigned short    PCR_pid;
  unsigned short    ECM_PID;
  unsigned short    SID_pid;
  unsigned short    AC3_pid;
  unsigned char     TVType;                     //  == 00 PAL ; 11 == NTSC
  unsigned char     ServiceTyp;
  unsigned char     CA_ID;
  unsigned short    Temp_Audio;
  unsigned short    Filteranzahl;
  struct TPIDFilters Filters[MAX_PID_IDS];      // Vergrert auf 32 Eintrge
  unsigned short    CA_Anzahl;
  struct TCA_System82 CA_System[MAX_CA_SYSTEMS]; // Vergrert auf 32 Eintrge  ( Neues PMT-Parsing )
  char              CA_Land[5];
  unsigned char     Merker;
  unsigned short    Link_TP;
  unsigned short    Link_SID;
  unsigned char     Dynamisch;
  char              Extern_Buffer[16]; // 2 first bytes = sat longitude
                                       // thank you vlinders
};

} // end extern "C"
